Package tigase.util.ui.console

## Class CommandlineParameter

- java.lang.Object
- - tigase.util.ui.console.CommandlineParameter

-     public class CommandlineParameter
      extends java.lang.Object

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `CommandlineParameter.Builder` | Creates a `CommandlineParameter` builder

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object o)` |
    `java.util.Optional<java.lang.String>` | `getDefaultValue()` | Retrieves default value for this parameter option
    `java.util.Optional<java.lang.String>` | `getDescription()` | Retrieves description for this parameter option
    `java.util.Optional<java.lang.String>` | `getFullName()` | Retrieves full name for this parameter option
    `java.util.Optional<java.lang.String>` | `getFullName​(boolean includeDash)` | Retrieves full name for this parameter option
    `java.util.Optional<java.util.List<java.lang.String>>` | `getSelectionOptions()` | Retrieves list of possible selection options for this parameter option
    `java.util.Optional<java.lang.String>` | `getSingleLetter()` | Retrieves single letter identification for this parameter option
    `java.util.Optional<java.lang.String>` | `getSingleLetter​(boolean includeDash)` | Retrieves single letter identification for this parameter option
    `java.lang.Class` | `getType()` | Retrives expected class of a parameter
    `java.util.Optional<java.lang.String>` | `getValue()` | Retrieves stored value for this parameter option
    `java.util.List<CommandlineParameter>` | `getValueDependentParameters()` |
    `int` | `hashCode()` |
    `boolean` | `hasValueDependentParameters()` |
    `boolean` | `isRequireArguments()` | Retrieves information whether this parameter option requires arguments
    `boolean` | `isRequired()` | Retrieves information whether this parameter option is required
    `boolean` | `isSecret()` | Retrieves information whether this parameter option is secret
    `void` | `setValue​(java.lang.String value)` | Sets value for this parameter option
    `void` | `setValueFromDefault()` | Sets the value from the configured default if present
    `java.lang.String` | `toString()` |
    `java.lang.String` | `toStringSimple()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### equals

          public boolean equals​(java.lang.Object o)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### getDefaultValue

          public java.util.Optional<java.lang.String> getDefaultValue()

      Retrieves default value for this parameter option
      Returns:
        Optional for the default value

    - #### getDescription

          public java.util.Optional<java.lang.String> getDescription()

      Retrieves description for this parameter option
      Returns:
        Optional for the description

    - #### getFullName

          public java.util.Optional<java.lang.String> getFullName​(boolean includeDash)

      Retrieves full name for this parameter option
      Parameters:
        `includeDash` - controls whether dashes should be included
      Returns:
        Optional for the full name (which may include dashes depending on parameter)

    - #### getFullName

          public java.util.Optional<java.lang.String> getFullName()

      Retrieves full name for this parameter option
      Returns:
        Optional for the full name

    - #### getSelectionOptions

          public java.util.Optional<java.util.List<java.lang.String>> getSelectionOptions()

      Retrieves list of possible selection options for this parameter option
      Returns:
        Optional list of the possible selection options

    - #### getSingleLetter

          public java.util.Optional<java.lang.String> getSingleLetter()

      Retrieves single letter identification for this parameter option
      Returns:
        Optional for the single letter

    - #### getSingleLetter

          public java.util.Optional<java.lang.String> getSingleLetter​(boolean includeDash)

      Retrieves single letter identification for this parameter option
      Parameters:
        `includeDash` - controls whether dash should be included
      Returns:
        Optional for the single letter (which may include dash depending on parameter)

    - #### getType

          public java.lang.Class getType()

      Retrives expected class of a parameter

    - #### getValue

          public java.util.Optional<java.lang.String> getValue()

      Retrieves stored value for this parameter option
      Returns:
        Optional with the stored value

    - #### setValue

          public void setValue​(java.lang.String value)

      Sets value for this parameter option
      Parameters:
        `value` - to be set

    - #### getValueDependentParameters

          public java.util.List<CommandlineParameter> getValueDependentParameters()

    - #### hasValueDependentParameters

          public boolean hasValueDependentParameters()

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### isRequireArguments

          public boolean isRequireArguments()

      Retrieves information whether this parameter option requires arguments
      Returns:
        true if the parameter option requires arguments

    - #### isRequired

          public boolean isRequired()

      Retrieves information whether this parameter option is required
      Returns:
        true if the parameter option is required

    - #### isSecret

          public boolean isSecret()

      Retrieves information whether this parameter option is secret
      Returns:
        true if the parameter option is secret

    - #### setValueFromDefault

          public void setValueFromDefault()

      Sets the value from the configured default if present

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toStringSimple

          public java.lang.String toStringSimple()